<?php
	/*
	 * Plugin Name: In8Sync Customization
	 * Version: 3.2.16.1
	 * Author: In8Sync
	 * Author URI: http://www.in8sync.com
	 */
	
	
	if (!defined('ABSPATH')) {
		exit; // Exit if accessed directly
	}
	
	define('IN8_CUSTOMIZATION_LINK', plugin_dir_url(__FILE__));
	define('IN8_CUSTOMIZATION_PATH', plugin_dir_path(__FILE__));
	
	// add custom css file
	add_action('wp_enqueue_scripts', function(){
		wp_enqueue_style('in8sync-customization-css', IN8_CUSTOMIZATION_LINK.'css/styles.css');
		wp_enqueue_script('in8sync-customization-js', IN8_CUSTOMIZATION_LINK.'js/scripts.js', ['jquery']);
	});





function in8sync_override_data($order_data, $order_id) {
                  
     $order = wc_get_order($order_id);

	//$promotions = array();
	$promotionsarraycontainer = array();
// 	$promotionsarraycontainer[] = array("couponcode"=>445);
// 	$promotionsarraycontainer[] = array("couponcode"=>444);

	
	$netsuite_promotion_ids = get_post_meta( $order_id, 'netsuite_promotion_ids', true );
	if ( ! empty( $netsuite_promotion_ids ) ) {
		$promotionsarraycontainer = json_decode( $netsuite_promotion_ids );
		/* 
		 * jeremy@bicycletheory.com 2022-02-18: replaced the below with json_decode() above, because
		 * that's all that was needed, and the below leaves a coupon code of 0 in the data, which
		 * causes a sync error.
		 * 
		$pieces = explode(",", $netsuite_promotion_ids);
		foreach ($pieces as $couponinternalid) {
			$couponpieces = explode(":", $couponinternalid);
			$outputString = preg_replace('/[^0-9]/', '', $couponpieces[1]);  
			$promotionsarray = array();
			$promotionsarray['couponcode'] = (int)$outputString;
			$promotionsarraycontainer[] = $promotionsarray;
		}
		*/
	}
	
	
// 	$order_items = $order->get_items('coupon');
// 	// LOOP THROUGH ORDER COUPON ITEMS
// 	foreach( $order_items as $item_id => $item ){
		
// 		$promotionsarray = array();

// 		// Retrieving the coupon ID reference
// 		$coupon_post_obj = get_page_by_title( $item->get_name(), OBJECT, 'shop_coupon' );
// 		$coupon_id = $coupon_post_obj->ID;

// 		// Get an instance of WC_Coupon object (necessary to use WC_Coupon methods)
// 		$coupon = new WC_Coupon($coupon_id);
		
// 		$couponinternalid = get_post_meta( $coupon_id, 'internalid', true );
// 		// Check if the custom field has a value.
			
// 		if ( ! empty( $couponinternalid ) ) {
// 			$promotionsarray['couponcode'] = $couponinternalid;
// 			$order_data['test2'] = 'test2';
// 		}
// 		$promotionsarraycontainer[] = $promotionsarray;
// 	}
      
     $order_data['promotions'] = $promotionsarraycontainer;
                  
     return $order_data;
 }
 add_filter('in8sync_so_order_after_data_prepared', 'in8sync_override_data', 10, 4);





//Send grind type as line item data in NS
function in8sync_override_item_grind( $item, $order_id, $order_item_key, $order_item ) {
     
    if(!empty($order_item->get_meta('regular_price'))) {
        $item['custcol_web_reg_price'] = $order_item->get_meta('regular_price');
    }
	if(!empty($order_item->get_meta('pricing_note'))) {
        $item['custcol_web_price_note'] = $order_item->get_meta('pricing_note');
    }
	if(!empty($order_item->get_meta('line_tax_charged'))) {
        $item['custcol_web_line_tax'] = $order_item->get_meta('line_tax_charged');
    }
    return $item;
}
add_filter( 'in8_so_sync_line_item', 'in8sync_override_item_grind', 10, 4 );
